import Taro from '@tarojs/taro'
export const sendRequest = (url, method = 'GET', data = {}, contentType) => {
  const reqUrl = url.indexOf('http') == -1 ? `${process.env.TARO_APP_API}${url}` : url
  const token = Taro.getStorageSync('token') || ''

  return new Promise((resolve, reject) => {
    Taro.request({
      url: reqUrl,
      data: data,
      method: method,
      timeout: 15000,
      header: {
        ...contentType,
        Authorization: `Bearer ${token}`
      },
      success: function (res) {
        if (url.indexOf('http') == -1) {
          const data = res.data
          if (data.code == 200) {
            resolve(data.data)
          } else if (data.code == 901) {
            // Taro.reLaunch({ url: '/packageA/pages/login/index' })
          } else {
            Taro.showToast({ title: data.msg, icon: 'none' })
          }
        } else {
          if (res.statusCode == 200) {
            resolve(res.data)
          } else {
            reject(res.data)
          }
        }
      },
      fail: function (res) {
        console.log(JSON.stringify(res), `${process.env.TARO_APP_API}${url}`, 'Taro.request')
        reject(res)
        if (res.errno == '600003') return
        if (res.errMsg == 'request:fail timeout') {
          Taro.showToast({ title: '请求超时，请重新尝试', icon: 'none' })
        } else {
          Taro.showToast({ title: '服务器错误', icon: 'none' })
        }
      }
    })
  })
}
