import { View, Image, Text } from '@tarojs/components'
import './index.less'
import connectble from "@/assets/connectble.png";
import addDev from "@/assets/addDev.png";
import router from '@/baseRouter/index'
import BLESDK from '@/utils/ble'
import { useEffect, useState } from 'react';
import Taro, { useDidShow } from '@tarojs/taro';

export default function Index() {
  const [isLink, setIsLink] = useState(BLESDK.deviceInfo.state)

  const addDevice = () => {
    router.navigate('/pages/deviceList/index')
  }
  const deviceCallBack = () => {
    setIsLink(BLESDK.deviceInfo.state)
  }
  useDidShow(() => {
    BLESDK.deviceCallBack(deviceCallBack)
    setIsLink(BLESDK.deviceInfo.state)
  })
  useEffect(() => {
    if (BLESDK.deviceInfo.name) {
      BLESDK.createBleConnection()
    }
  }, [])

  const unbind = () => {
    Taro.showModal({
      title: '解绑设备',
      content: '确认解绑当前设备？',
      success: (res) => {
        if (res.confirm) {
          setIsLink(false)
          BLESDK.unBindDevice()
          Taro.removeStorageSync('deviceInfo')
          Taro.showToast({ title: '设备解绑成功', icon: 'success' })
        }
      }
    })
  }
  console.log(BLESDK.deviceInfo, BLESDK.deviceInfo?.name ? 1 : 2, 'BLESDK.deviceInfo');

  return (
    <View className="index device">
      {BLESDK.deviceInfo?.name ? <>
        <View className="deviceinfo">
          <Image src={connectble} className='deviceimg' />
          <View className="item">
            <View className="item-label">连接状态</View>
            <View className="item-text active">{isLink ? '已连接' : '未连接'}</View>
          </View>
          <View className="item">
            <View className="item-label">设备名称</View>
            <View className="item-text">{BLESDK.deviceInfo.name}</View>
          </View>
          <View className="item">
            <View className="item-label">MAC 地址</View>
            <View className="item-text">{BLESDK.deviceInfo.mac}</View>
          </View>
        </View>
        <View className='btn' onClick={unbind}>解绑设备</View>
      </> :
        <View className='adddevice' onClick={addDevice}>
          <Image src={addDev} className='addimg' />
          <View className='text'>添加设备</View>
        </View>
      }
    </View>
  )
}
