import { View, Image } from "@tarojs/components";

import "./index.less";
import { useEffect, useState } from "react";
import Taro from "@tarojs/taro";
import empty from "@/assets/empty.png";
import router from '@/baseRouter/index'

export default function Index() {
  let [history, setHistory] = useState(Taro.getStorageSync("colorList") || [])

  const delItem = (index) => {
    Taro.showModal({
      title: '提示',
      content: '是否确认删除？',
      success: (res) => {
        if (res.confirm) {
          history.splice(index, 1)
          setHistory([...history])
          Taro.setStorageSync("colorList", history)
        }
      }
    })
  }

  const useItem = (item) => {
    router.back(item)
  }


  return (
    <View className="history index">
      {
        history.length ?
          <View>
            {
              history.map((item, index) => <View className="card" key={index}>
                <View className="grid">
                  {item.map((ite, ide) => <View className="grid-item" style={{ backgroundColor: `rgb(${ite})` }} key={`_${ide}`}></View>)}
                </View >
                <View className="btns">
                  <View className="btn del" onClick={() => delItem(index)}>删除</View>
                  <View className="btn use" onClick={() => useItem(item)}>使用</View>
                </View>
              </View>)
            }
          </View> :
          <View className="empty">
            <Image src={empty} className="empty-img" />
            <View className="empty-text">暂无历史记录</View>
          </View>
      }
    </View>
  );
}
