import { View } from '@tarojs/components'
import './index.less'
import { Button } from "@taroify/core"
import BLESDK from '../../utils/ble'
import Taro, { useDidShow } from '@tarojs/taro'
import { useState } from 'react'
import { getInitData } from '@/utils/sendOrder'

export default function Index() {
  const [deviceInfo, setDeviceInfo] = useState(BLESDK.deviceInfo)
  const [disabled, setDisabled] = useState(!!BLESDK.deviceInfo.state)
  const [loading, setLoading] = useState(false)
  const deviceCallBack = () => {
    setDeviceInfo({ ...BLESDK.deviceInfo })
    if (BLESDK.deviceInfo.state) {
      setDisabled(true)
    }
  }
  const lookSleep = () => {
    // if (!BLESDK.deviceInfo.state) return Taro.showToast({ title: '请先连接设备', icon: 'none' })
    Taro.navigateTo({ url: '/pages/funList/index' })
  }

  useDidShow(() => {
    BLESDK.deviceCallBack(deviceCallBack)
    setDeviceInfo({ ...BLESDK.deviceInfo })
    setDisabled(!!BLESDK.deviceInfo.state)
  })

  const searchBluetooth = () => {
    BLESDK.startBluetoothDevicesDiscovery()
    setLoading(true)
    setDisabled(true)
    setTimeout(() => {
      BLESDK.stopBluetoothDevicesDiscovery();
      setLoading(false)
      setDisabled(!!BLESDK.deviceInfo.state)
    }, 6000)
  }

  return (
    <View className="index">
      <View className='device'>
        <View className='item'>
          <View className='item-label'>NAME：</View>
          <View className='item-text'>{deviceInfo.name || '--'}</View>
        </View>
        <View className='item'>
          <View className='item-label'>MAC：</View>
          <View className='item-text'>{deviceInfo.mac || '--'}</View>
        </View>
        <View className='item'>
          <View className='item-label'>连接状态：</View>
          <View className='item-text' style={{ color: deviceInfo.state ? 'green' : 'red' }}>{deviceInfo.name ? deviceInfo.state ? '已连接' : '未连接' : '--'}</View>
        </View>
      </View>
      <Button color="info" className='btn' disabled={!!!BLESDK.deviceInfo.state} onClick={getInitData} >获取设备初始化状态</Button>
      <Button color="info" className='btn' disabled={!!!BLESDK.deviceInfo.state} onClick={lookSleep}>功能设置</Button>
      <Button color="warning" className='btn connect' disabled={disabled} loading={loading} onClick={searchBluetooth}>连接设备</Button>
    </View >
  )
}
